this.name			= "Test_moons_planets.oxp";
this.author			= "Vladimir P. Tch";
this.copyright		= "Creative Commons Attribution-Noncommercial-Share Alike 3.0 Unported License";
this.licence		= "CC BY-NC-SA 3.0 (Creative Commons Attribution-Noncommercial-Share Alike 3.0 Unported License)";
this.description	= "Специально для vasig - спутники на орбитах возле планетоидов на Вашем испытательном Полигоне";
this.version		= "1.0.0 (2013-12-28)";
/*
Этот пакет создаёт спутники на орбитах вокруг планетоидов на Вашем испытательном Полигоне, чтобы было не скучно проводить Ваши эксперименты с гравитацией и орбитальными полётами. В этом пакете рассчитываются характеристики орбит и данные передатся по установленному протоколу обмена в пакет "Tch_Gravitation.oxp" для дальнейшей обработки.

Орбитальные стации берутся из моего пакета "Tch_Stations_models_1.0.0_2013-06-22". Для экспериментов со стыковками с орбитальными станциями-спутниками я поставил станции класса "transhab" - они для этих целей наиболее удобны. Остальные станции - "Медузы", "Гулаги" - более для декораций. С ними и в обычных условиях трудно состыковаться, а уж на орбите - тем более!

Да, и теперь спутники создаются около планет на заданной высоте (высота задаётся в метрах! если надо "подвесить" спутник на высоте 500 км, то нужно написать 5000, так как 1 астрономический километр = 10 игровых метров, не перепутайте!), но в случайном месте, а сами они "привязаны" только к планетоиду, около которого будут летать. Можно передвинуть планетоиды - должны вмести с ними переместиться и спутники. Надо пробовать и проверять.
*/

this.func_Average_Density_Planet = function( ObjectPlanet ){
	var nAverage_Density_Planet = 5000;
	if (ObjectPlanet.isMainPlanet){
		nAverage_Density_Planet = 5000;
	}
	else {
		if (ObjectPlanet.hasAtmosphere){
			if (ObjectPlanet.radius < 10E4){
				nAverage_Density_Planet = 5000;
			}
			else {
				nAverage_Density_Planet = 2000;
			}
		}
		else {
			nAverage_Density_Planet = 4000;
		}
	}
	return nAverage_Density_Planet;
}
this.startUp = function(){
	this.bEvent_Add_Sputniks = true;
}
this.shipExitedWitchspace = this.shipLaunchedFromStation = function(){
	var nGalaxy = 0;
	var nSystID = 72;
	if ((galaxyNumber == nGalaxy) && (system.ID == nSystID)){
		if (this.bEvent_Add_Sputniks){
			this.bEvent_Add_Sputniks = false;
			
			var aSputnik_01 = new Array("Earth_Moon",	"transhab",	"",			 0, 0, 0,  8000, 0, 0, 0,         0, 0, 0, 1, 0, 0);
			var aSputnik_02 = new Array("Earth_Moon",	"shuttle",	"Earth",	 0, 0, 0,  1000, 0, 0, Math.PI/4, 0, 0, 0, 5, 0, 0);
			var aSputnik_03 = new Array("Earth_Moon",	"shuttle",	"Jupiter",	 0, 0, 0,  5000, 0, 0, Math.PI/8, 0, 0, 0, 5, 0, 0);
			
			var aSputnik_04 = new Array("Earth",		"transhab",	"",			 0, 0, 0, 30000, 0, 0, 0,         0, 0, 0, 1, 0, 0);
			var aSputnik_05 = new Array("Earth",		"shuttle",	"Jupiter",	 0, 0, 0,  1000, 0, 0, Math.PI/3, 0, 0, 0, 5, 0, 0);
			var aSputnik_06 = new Array("Earth",		"transhab",	"",			 0, 0, 0, 10000, 0, 0, Math.PI/6, 0, 0, 0, 3, 0, 0);
			
			var aSputnik_07 = new Array("Jupiter",		"transhab",	"",			 0, 0, 0,400000, 0, 0, 0,         0, 0, 0, 1, 0, 0);
			var aSputnik_08 = new Array("Jupiter",		"shuttle",	"Earth",	 0, 0, 0,  1000, 0, 0, Math.PI/2, 0, 0, 0, 5, 0, 0);
			var aSputnik_09 = new Array("Jupiter",		"commi-slapu",	"",		 0, 0, 0,300000, 0, 0, Math.PI/8, 0, 0, 0, 4, 0, 0);
			var aSputnik_10 = new Array("Jupiter",		"nuit",		"Earth",	 0, 0, 0,600000, 0, 0, Math.PI/6, 0, 0, 0, 1, 0, 0);
			
			global.Tch_aSputniks = new Array( aSputnik_01, aSputnik_02, aSputnik_03, aSputnik_04, aSputnik_05, aSputnik_06, aSputnik_07, aSputnik_08, aSputnik_09, aSputnik_10 );
			for ( var mt1 = 0; mt1 < global.Tch_aSputniks.length; mt1++){
				var aPlanets = system.planets;
				var nNumberPlanet = 999;
				var sNamePlanet = global.Tch_aSputniks[mt1][0];
				for (var mt2 = 0; mt2 < aPlanets.length; mt2++){
					if (globfunc_Translate_NameTexture_NamePlanet( aPlanets[mt2].texture ) == global.Tch_aSputniks[mt1][0]){
						nNumberPlanet = mt2;
						mt2 = aPlanets.length;
					}
				}
				if (nNumberPlanet != 999){
					global.Tch_aSputniks[mt1][0] = aPlanets[nNumberPlanet].position;
					global.Tch_aSputniks[mt1][3] = globfunc_Position_Object_aboutObject( aPlanets[nNumberPlanet], (aPlanets[nNumberPlanet].radius + global.Tch_aSputniks[mt1][6]), (aPlanets[nNumberPlanet].radius + global.Tch_aSputniks[mt1][6]));
					var aTemp = system.addShips( global.Tch_aSputniks[mt1][1], 1, global.Tch_aSputniks[mt1][3] );
					if (aTemp.length > 0){
						global.Tch_aSputniks[mt1][1] = aTemp[0];
						if (global.Tch_aSputniks[mt1][1].isStation){
						}
						else {
							global.Tch_aSputniks[mt1][1].awardEquipment("EQ_ESCAPE_POD");
							global.Tch_aSputniks[mt1][1].abandonShip();
						}
						var nNumberBeacon = 999;
						var sNameBeacon = global.Tch_aSputniks[mt1][2];
						for (var mt2 = 0; mt2 < aPlanets.length; mt2++){
							if (globfunc_Translate_NameTexture_NamePlanet( aPlanets[mt2].texture ) == global.Tch_aSputniks[mt1][2]){
								nNumberBeacon = mt2;
								mt2 = aPlanets.length;
							}
						}
						if (nNumberBeacon != 999){
							global.Tch_aSputniks[mt1][2] = aPlanets[nNumberBeacon].position;
						}
						else {
							global.Tch_aSputniks[mt1][2] = system.mainPlanet.position;
							sNameBeacon = "Главная планета G" + (galaxyNumber + 1) + " ID" + system.ID + " " + system.name;
						}
						global.Tch_aSputniks[mt1][4] = new Vector3D( global.Tch_aSputniks[mt1][3].subtract( global.Tch_aSputniks[mt1][0] ) );
						global.Tch_aSputniks[mt1][5] = Math.floor( global.Tch_aSputniks[mt1][4].magnitude() );
						global.Tch_aSputniks[mt1][6] = global.Tch_aSputniks[mt1][5] - aPlanets[nNumberPlanet].radius;
						var nAverage_Density_Planet = this.func_Average_Density_Planet( aPlanets[nNumberPlanet] );
						global.Tch_aSputniks[mt1][7] = 0.00000167 * Math.sqrt(( nAverage_Density_Planet * aPlanets[nNumberPlanet].radius * aPlanets[nNumberPlanet].radius * aPlanets[nNumberPlanet].radius ) / global.Tch_aSputniks[mt1][5] );
						global.Tch_aSputniks[mt1][8] = (( 6.283 * global.Tch_aSputniks[mt1][5] ) / ( global.Tch_aSputniks[mt1][7] * 10 ));
						global.Tch_aSputniks[mt1][15] = system.mainPlanet.position;
						globfunc_Orientation_toPosition( global.Tch_aSputniks[mt1][1], global.Tch_aSputniks[mt1][15] );
						globfunc_Orientation_aboutPosition( global.Tch_aSputniks[mt1][1], global.Tch_aSputniks[mt1][0], Math.PI/2 );
						globfunc_Orientation_aroundPosition( global.Tch_aSputniks[mt1][1], global.Tch_aSputniks[mt1][0], global.Tch_aSputniks[mt1][9] );
						global.Tch_aSputniks[mt1][10] = global.Tch_aSputniks[mt1][1].heading.cross( global.Tch_aSputniks[mt1][4] ).direction();
						global.Tch_aSputniks[mt1][11] = ( global.Tch_aSputniks[mt1][7] * 10 )/ global.Tch_aSputniks[mt1][5];
						global.Tch_aSputniks[mt1][12] = global.Tch_aSputniks[mt1][11] * 0.25;
						var nAngle = global.Tch_aSputniks[mt1][12] * global.Tch_aSputniks[mt1][13];
						var ncos = Math.cos( nAngle/2 );
						var nsin = Math.sin( nAngle/2 );
						global.Tch_aSputniks[mt1][14] = new Quaternion( ncos, global.Tch_aSputniks[mt1][10].x * nsin, global.Tch_aSputniks[mt1][10].y * nsin, global.Tch_aSputniks[mt1][10].z * nsin );
					}
					else {
						global.Tch_aSputniks[mt1][1] = "отсутствует";
					}
				}
				else {
					global.Tch_aSputniks[mt1][0] = "отсутствует";
				}
			}
		}
	}
}
this.shipWillEnterWitchspace = function(){
	global.Tch_aSputniks = new Array()
	this.bEvent_Add_Sputniks = true;
}
